; ======================================
; Depack routine.
;
; Includes packed data at the end of the file.
; Set LOADADDRESS and STARTADDRESS as required.
; ======================================

DEPACKER        = $0100                 ; Fits in the stack, actually.
LOADADDRESS     = $0810
STARTADDRESS    = $0810

dest    = $60
src     = $62
bi      = $64
string  = $66

        processor 6502

        org $0801
; Basic tokens for the line '2000 SYS2064'
        .byte $0B,$08,$D0,$07,$9E,$32,$30,$36,$34,$5a,$45,$44,$00,$00

        org $0810

; Print depacking... message.
        lda #<depacktext
        ldy #>depacktext
        jsr $ab1e

        sei
        lda #$34
        sta $01
        ldy #DEPACKLEN
copydepacker:
        lda depackstart-1,y
        sta DEPACKER-1,y
        dey
        bne copydepacker

; Copy to top of mem. src and dest are reversed in their meaning!
        sty src
        sty src+1
        ldx #DATAPAGES
copyup_loop:
        dec copyup_innerloop+2
        dec src+1
copyup_innerloop:
        lda datastart+256*DATAPAGES,y
        sta (src),y
        iny
        bne copyup_innerloop
        dex
        bne copyup_loop
        lda #<LOADADDRESS
        sta dest
        lda #>LOADADDRESS
        sta dest+1
        jmp DEPACKER

depacktext:
        .byte $44,$45,$50,$41,$43,$4b,$49,$4e,$47,$2e,$2e,$2e,$00 ; depacking...

; Depacker.
depackstart:
        rorg DEPACKER

depackloop:
        jsr getbyte
        lsr
        beq depackready
        bcs compressedblock

; Uncompressed block.
        tax
uncompressedloop:
        jsr getbyte
        jsr putbyte
        dex
        bne uncompressedloop
        beq depackloop

; RLE or string block.
compressedblock:
        lsr
        tax
        bcs stringblock

; RLE block.
        jsr getbyte
rleloop:
        jsr putbyte
        dex
        bne rleloop
        beq depackloop

stringblock:
        jsr getbyte
        sta bi
        jsr getbyte
        sta bi+1
        lda dest
        sec
        sbc bi
        sta string
        lda dest+1
        sbc bi+1
        sta string+1
stringblockloop:
        lda (string),y
        inc string
        bne getstringbyteok
        inc string+1
getstringbyteok:
        jsr putbyte
        dex
        bne stringblockloop
        beq depackloop

depackready:
        ldx #$ff
        txs
        lda #$37
        sta $01
        cli
        jmp STARTADDRESS

getbyte:
        lda (src),y
        inc src
        bne getbyteok
        inc src+1
getbyteok:
        rts

putbyte:
        sta (dest),y
        inc dest
        bne putbyteok
        inc dest+1
putbyteok:
        rts

        rend

DEPACKLEN       = *-depackstart


datastart:
        incbin packed.bin
dataend:
DATAPAGES       = >(dataend-datastart+$ff)
