/*
  argv[1]: frequency of A-4 in Hz. (usually 440)
*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

// #define exactly 1 of these clock speeds.

//#define FCLK    985248.0                // For PAL.
//#define FCLK    1022700.0               // For NTSC.
#define FCLK    1000000.0               // For what? Atlantis maybe?

#ifndef M_LN2
#define M_LN2       0.693147180559945309417
#endif


void makeFreqTable(double a4)
{
  double c7;
  int o, n;
  double f, od;
  long sidf;

  c7=exp(27.0*M_LN2/12.0)*a4;
  for (o=0; o<8; o++) {
    od=1<<(7-o);
    for (n=0; n<12; n++) {
      f=exp(n*M_LN2/12.0)*c7/od;
      sidf=(long)(f*16777216.0/FCLK+0.5);
      if (n==0) printf("        .word");
      printf(" %5ld", sidf);
      if (n!=11) printf(",");
      else printf("   ; octave %d\n", o);
    }
  }
}


int main(int argc, char *argv[])
{
  double a4;

  sscanf(argv[1], "%lf", &a4);
  makeFreqTable(a4);
  return EXIT_SUCCESS;
}
