/*
  ASCII to PETSCII converter.

  Read stdin, write stdout.

  Wotan mit uns.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int Ascii2PetsciiChar(int c)
{
  if ((c>=0x20)&&(c<0x41)) return c;
  if ((c>=0x41)&&(c<0x5b)) return c+0x80;
  if ((c>=0x5b)&&(c<0x60)) return c;
  if ((c>=0x61)&&(c<0x7b)) return c-0x20;
  fprintf(stderr, "Conversion not defined for ASCII 0x%02x.\n", c);
  return c;
}


int Ascii2PetsciiFile(FILE *in, FILE *out)
{
  int l, i, c;
  char inbuf[80];

  fgets(inbuf, sizeof(inbuf)-1, in);
  while (!feof(in)) {
    l=strlen(inbuf)-1;
    fprintf(out, "; %s", inbuf);
    fprintf(out, "        .byte ");
    for (i=0; i<l; i++) {
      c=Ascii2PetsciiChar((unsigned char)inbuf[i]);
      fprintf(out, "$%02x,", c);
    }
    fprintf(out, "$0d\n");
    fgets(inbuf, sizeof(inbuf)-1, in);
  }
  return 0;
}


int main(int argc, char *argv[])
{
  Ascii2PetsciiFile(stdin, stdout);

  return EXIT_SUCCESS;
}
